function setupEPer = infoToSetupEPer(model,setupEPer)
setupEPer.ny         = model.ny;
setupEPer.nx         = model.nx;
setupEPer.ne         = model.ne;
setupEPer.nx1        = model.nx-model.ne;
setupEPer.mx         = model.mx;
setupEPer.myx        = model.myx;
setupEPer.h0         = model.h0;
setupEPer.hx         = model.hx;
setupEPer.g0         = model.g0;
setupEPer.params     = model.params;
setupEPer.updateJDefaultOn = 1;

% Expectational moments for the Extended Path
if setupEPer.MexOn == 1
    firstOn    = 1; %i.e. we reproduce loadings for y_t in yEx, yExx, yExxx, and yE4x
    [setupEPer.yEx,setupEPer.yExx,setupEPer.yExxx,setupEPer.yE4x] = CondMoments_4th_levelCE_Mex(...
        model.gx,model.gxx,model.gxxx,model.g4x,...
        model.hx,model.hxx,model.hxxx,model.h4x,...
        setupEPer.Nmax,firstOn,setupEPer.orderAppStart,model.ny,model.nx);
    firstOn    = 1; %i.e. we reproduce loadings for x_t in xEx, xExx, xExxx, and xE4x
                    %because it implies x_t+1 = hx*x_t at first order,
                    %which is the first variable we solve for in the Extended Path
    [setupEPer.xEx,setupEPer.xExx,setupEPer.xExxx,setupEPer.xE4x] = CondMoments_4th_levelCE_Mex(...
        model.hx,model.hxx,model.hxxx,model.h4x,...
        model.hx,model.hxx,model.hxxx,model.h4x,...
        setupEPer.Nmax,firstOn,setupEPer.orderAppStart,model.nx,model.nx);
else
    firstOn    = 1; %i.e. we reproduce loadings for y_t in yEx, 
    [setupEPer.yEx,setupEPer.yExx,setupEPer.yExxx,setupEPer.yE4x] = CondMoments_4th_levelCE_v3(...
        model.gx,model.gxx,model.gxxx,model.g4x,...
        model.hx,model.hxx,model.hxxx,model.h4x,...
        setupEPer.Nmax,firstOn,setupEPer.orderAppStart);
    firstOn    = 1; %i.e. we reproduce loadings for x_t in xEx, xExx, xExxx, and xE4x
                    %because it implies x_t+1 = hx*x_t at first order,
                    %which is the first variable we solve for in the Extended Path
    [setupEPer.xEx,setupEPer.xExx,setupEPer.xExxx,setupEPer.xE4x] = CondMoments_4th_levelCE_v3(...
        model.hx,model.hxx,model.hxxx,model.h4x,...
        model.hx,model.hxx,model.hxxx,model.h4x,...
        setupEPer.Nmax,firstOn,setupEPer.orderAppStart);
end

end