function F = DSGEforesight_N(Z,x_t,y_tN,N,setupEPer)
 
%Unfold some elements in setupEper
nx        = setupEPer.nx;
mx        = setupEPer.mx;
myx       = setupEPer.myx;
ny        = setupEPer.ny;
params    = setupEPer.params;
hx        = setupEPer.hx;
 
%Unfold params
DELTA= params.DELTA;
BETTA= params.BETTA;
GAMA= params.GAMA;
PHI= params.PHI;
ALFA= params.ALFA;
RHOA= params.RHOA;
 
% Retrieving stacked variables
[x,y] = VarStack(Z,nx,mx,myx,ny,hx,x_t,y_tN,N);
 
% Adding the level to the variables
y = y + repmat(transpose(setupEPer.g0),N+1,1);
x = x + repmat(transpose(setupEPer.h0),N+1,1);
 
% Current values in the model;
% x(N,mx) y(N,ny);
% x;
k1_cu = x(1:N,1);
k2_cu = x(1:N,2);
k3_cu = x(1:N,3);
k4_cu = x(1:N,4);
a1_cu = x(1:N,5);
a2_cu = x(1:N,6);
a3_cu = x(1:N,7);
a4_cu = x(1:N,8);
% xp;
k1_cup = x(2:N+1,1);
k2_cup = x(2:N+1,2);
k3_cup = x(2:N+1,3);
k4_cup = x(2:N+1,4);
a1_cup = x(2:N+1,5);
a2_cup = x(2:N+1,6);
a3_cup = x(2:N+1,7);
a4_cup = x(2:N+1,8);
 
% y
c1_cu = y(1:N,1);
c2_cu = y(1:N,2);
c3_cu = y(1:N,3);
c4_cu = y(1:N,4);
iv1_cu = y(1:N,5);
iv2_cu = y(1:N,6);
iv3_cu = y(1:N,7);
iv4_cu = y(1:N,8);
la_cu = y(1:N,9);
% yp;
c1_cup = y(2:N+1,1);
c2_cup = y(2:N+1,2);
c3_cup = y(2:N+1,3);
c4_cup = y(2:N+1,4);
iv1_cup = y(2:N+1,5);
iv2_cup = y(2:N+1,6);
iv3_cup = y(2:N+1,7);
iv4_cup = y(2:N+1,8);
la_cup = y(2:N+1,9);
 
%% Setting the dimension of the matrices 
f = zeros(ny+mx,N);
%% f Function evaluation
% START DISPLAYING f
f(1,:)=(exp(-la_cu).*(-(BETTA - 1)./(ALFA.*BETTA)).^(1./GAMA))./exp(c1_cu).^(1./GAMA) - 1;
f(2,:)=(exp(-la_cu).*(-(BETTA - 1)./(ALFA.*BETTA)).^(1./GAMA))./exp(c2_cu).^(1./GAMA) - 1;
f(3,:)=(exp(-la_cu).*(-(BETTA - 1)./(ALFA.*BETTA)).^(1./GAMA))./exp(c3_cu).^(1./GAMA) - 1;
f(4,:)=(exp(-la_cu).*(-(BETTA - 1)./(ALFA.*BETTA)).^(1./GAMA))./exp(c4_cu).^(1./GAMA) - 1;
f(5,:)=exp(-k1_cup).*(exp(iv1_cu) - exp(k1_cu).*(DELTA - 1)) - 1;
f(6,:)=exp(-k2_cup).*(exp(iv2_cu) - exp(k2_cu).*(DELTA - 1)) - 1;
f(7,:)=exp(-k3_cup).*(exp(iv3_cu) - exp(k3_cu).*(DELTA - 1)) - 1;
f(8,:)=exp(-k4_cup).*(exp(iv4_cu) - exp(k4_cu).*(DELTA - 1)) - 1;
f(9,:)=-(exp(-la_cu).*(exp(la_cu).*(PHI.*(DELTA - exp(-k1_cu).*exp(iv1_cu)) - 1) - BETTA.*exp(la_cup).*(PHI.*(DELTA - exp(-k1_cup).*exp(iv1_cup)).*((exp(-k1_cup).*exp(iv1_cup))./2 - DELTA./2 + 1) + (exp(a1_cup).*exp(k1_cup).^(ALFA - 1).*(BETTA - 1))./BETTA - 1)))./(PHI.*(DELTA - exp(-k1_cu).*exp(iv1_cu)) - 1);
f(10,:)=-(exp(-la_cu).*(exp(la_cu).*(PHI.*(DELTA - exp(-k2_cu).*exp(iv2_cu)) - 1) - BETTA.*exp(la_cup).*(PHI.*(DELTA - exp(-k2_cup).*exp(iv2_cup)).*((exp(-k2_cup).*exp(iv2_cup))./2 - DELTA./2 + 1) + (exp(a2_cup).*exp(k2_cup).^(ALFA - 1).*(BETTA - 1))./BETTA - 1)))./(PHI.*(DELTA - exp(-k2_cu).*exp(iv2_cu)) - 1);
f(11,:)=-(exp(-la_cu).*(exp(la_cu).*(PHI.*(DELTA - exp(-k3_cu).*exp(iv3_cu)) - 1) - BETTA.*exp(la_cup).*(PHI.*(DELTA - exp(-k3_cup).*exp(iv3_cup)).*((exp(-k3_cup).*exp(iv3_cup))./2 - DELTA./2 + 1) + (exp(a3_cup).*exp(k3_cup).^(ALFA - 1).*(BETTA - 1))./BETTA - 1)))./(PHI.*(DELTA - exp(-k3_cu).*exp(iv3_cu)) - 1);
f(12,:)=-(exp(-la_cu).*(exp(la_cu).*(PHI.*(DELTA - exp(-k4_cu).*exp(iv4_cu)) - 1) - BETTA.*exp(la_cup).*(PHI.*(DELTA - exp(-k4_cup).*exp(iv4_cup)).*((exp(-k4_cup).*exp(iv4_cup))./2 - DELTA./2 + 1) + (exp(a4_cup).*exp(k4_cup).^(ALFA - 1).*(BETTA - 1))./BETTA - 1)))./(PHI.*(DELTA - exp(-k4_cu).*exp(iv4_cu)) - 1);
f(13,:)=- ((PHI.*exp(k1_cu).*(DELTA - exp(-k1_cu).*exp(iv1_cu)).^2)./2 + (PHI.*exp(k2_cu).*(DELTA - exp(-k2_cu).*exp(iv2_cu)).^2)./2 + (PHI.*exp(k3_cu).*(DELTA - exp(-k3_cu).*exp(iv3_cu)).^2)./2 + (PHI.*exp(k4_cu).*(DELTA - exp(-k4_cu).*exp(iv4_cu)).^2)./2 + (exp(a1_cu).*exp(k1_cu).^ALFA.*(BETTA - 1))./(ALFA.*BETTA) + (exp(a2_cu).*exp(k2_cu).^ALFA.*(BETTA - 1))./(ALFA.*BETTA) + (exp(a3_cu).*exp(k3_cu).^ALFA.*(BETTA - 1))./(ALFA.*BETTA) + (exp(a4_cu).*exp(k4_cu).^ALFA.*(BETTA - 1))./(ALFA.*BETTA))./(exp(c1_cu) + exp(c2_cu) + exp(c3_cu) + exp(c4_cu) + exp(iv1_cu) + exp(iv2_cu) + exp(iv3_cu) + exp(iv4_cu) - DELTA.*exp(k1_cu) - DELTA.*exp(k2_cu) - DELTA.*exp(k3_cu) - DELTA.*exp(k4_cu)) - 1;
% END DISPLAYING f
 
F = reshape(f,N*(ny+mx),1);
end
