function [Q,residuals,R2,fit] = ObjectBlackTaylorRule(params,setup)
rLag = setup.r(1:end-1,1);
infl = setup.Infl(2:end,1);
yhat = setup.y(2:end,1);
r    = setup.r(2:end,1);

T = length(rLag);
residuals = zeros(T,1);
fit       = zeros(T,1);
for t=1:T
    fit(t,1) = params(1,1)+params(2,1)*log(1+rLag(t,1))+params(3,1)*infl(t,1)+params(4,1)*yhat(t,1);
    if fit(t,1) > 0
        residuals(t,1) = log(1+r(t,1))-fit(t,1);
    else
        fit(t,1) = 0;
        residuals(t,1) = log(1+r(t,1))-fit(t,1);
    end
end
Q = residuals'*residuals;

% Measure for goodness of fit
ym = r - ones(length(r),1)*mean(r);
rsqr1 = residuals'*residuals;
rsqr2 = ym'*ym;
R2 = 1.0 - rsqr1/rsqr2; % r-squared
end

