function [x1_cup,y_cu,diagSim,y_cup,Zfixed] = solutionExtendedPath(Z0,x_cu,y_tN,N,setupEPer)

setupEPer.dispOn = 0;
f0               = DSGEforesight_N(reshape(Z0,setupEPer.ny+setupEPer.mx,N),x_cu,y_tN,N,setupEPer); 

if setupEPer.fixedPointSolver == 1
    [Zfixed,fval,diff,iter,errorMes] = FixedPointSolver(Z0,x_cu,y_tN,N,setupEPer);
    usedSolver = 1;
elseif setupEPer.fixedPointSolver == 2
    [Zfixed,fval,diff,iter,errorMes] = FixedPointSolver_deltaOpt(Z0,x_cu,y_tN,N,setupEPer);
    usedSolver = 2;
elseif setupEPer.fixedPointSolver == 3
    % The unweighted NLS optimization
    MaxIter  = 500*2;
    weightOn = 0;
    [Zfixed,fval,diff,iter,Q,errorMes] = FixedPointSolver_LM(Z0,x_cu,y_tN,N,MaxIter,weightOn,setupEPer);
    usedSolver = 3;
elseif setupEPer.fixedPointSolver == 4
    % The weighted NLS optimization
    MaxIter  = 500;
    weightOn = 1;
    [Zfixed,fval,diff,iter,Q,errorMes] = FixedPointSolver_LM(Z0,x_cu,y_tN,N,MaxIter,weightOn,setupEPer);
    usedSolver = 4;
end
if errorMes ~= 0 && setupEPer.fixedPointSolver <= 3
    if setupEPer.dispOn == 1
        disp('Baseline fixed-point solver failed. New attempt by a NLS routine')
    end
    % We try the fixed-point solver with optimal delta step
    if fval'*fval < f0'*f0
        Zstart = Zfixed;
    else
        Zstart = Z0;
    end
    [Zfixed,fval,diff,iter,errorMes] = FixedPointSolver_deltaOpt(Zstart,x_cu,y_tN,N,setupEPer);
    usedSolver = 2;
    if errorMes == 1
        % Still no convergence - try LM solver
        % LM minimizer
        MaxIterLM = 20;
        if fval'*fval < f0'*f0
            ZstartLM = Zfixed;
        else
            ZstartLM = Z0;
        end
        weightOn = 0;
        setupEPerBackup = setupEPer;
        setupEPerBackup.lambda0 = setupEPer.lambdaBackup;
        [Zfixed,fval,diff,iter,Q,errorMes] = FixedPointSolver_LM(ZstartLM,x_cu,y_tN,N,MaxIterLM,weightOn,setupEPer);
        %weightOn = 0;
        %[Zfixed,fval,diff,iter,Q,errorMes] = FixedPointSolver_LM(Zfixed,x_cu,y_tN,N,MaxIterLM,weightOn,setupEPer);
        usedSolver = 3;
    end
end
Zfixed                    = real(Zfixed);
y_cu(:,1)                 = Zfixed(1:setupEPer.ny,1);
y_cup(:,1)                = Zfixed(1:setupEPer.ny,2);
x1_cup(1:setupEPer.nx1,1) = [Zfixed(setupEPer.ny+1:setupEPer.ny+setupEPer.mx,1);
                            y_cu(1:setupEPer.myx,1)];
diagSim                   = [max(abs(fval)) max(abs(fval(1:setupEPer.ny+setupEPer.mx,1))) iter usedSolver];

end

