function F = DSGEforesight_N(Z,x_t,y_tN,N,setupEPer)
 
%Unfold some elements in setupEper
nx        = setupEPer.nx;
mx        = setupEPer.mx;
myx       = setupEPer.myx;
ny        = setupEPer.ny;
params    = setupEPer.params;
hx        = setupEPer.hx;
 
%Unfold params
BETTA= params.BETTA;
PHIzero= params.PHIzero;
PHIone= params.PHIone;
PHItwo= params.PHItwo;
KAPA= params.KAPA;
DELTA= params.DELTA;
THETA= params.THETA;
ETA= params.ETA;
ALFA= params.ALFA;
RHOR= params.RHOR;
BETTAPAI= params.BETTAPAI;
BETTAY= params.BETTAY;
RHOA= params.RHOA;
RHOD= params.RHOD;
IV= params.IV;
K= params.K;
R= params.R;
PAI= params.PAI;
Y= params.Y;
 
% Retrieving stacked variables
[x,y] = VarStack(Z,nx,mx,myx,ny,hx,x_t,y_tN,N);
 
% Adding the level to the variables
y = y + repmat(transpose(setupEPer.g0),N+1,1);
x = x + repmat(transpose(setupEPer.h0),N+1,1);
 
% Current values in the model;
% x(N,mx) y(N,ny);
% x;
k_cu = x(1:N,1);
s_cu = x(1:N,2);
r_ba1 = x(1:N,3);
d_cu = x(1:N,4);
% xp;
k_cup = x(2:N+1,1);
s_cup = x(2:N+1,2);
r_ba1p = x(2:N+1,3);
d_cup = x(2:N+1,4);
 
% y
r_cu = y(1:N,1);
c_cu = y(1:N,2);
iv_cu = y(1:N,3);
pai_cu = y(1:N,4);
xtwo_cu = y(1:N,5);
y_cu = y(1:N,6);
w_cu = y(1:N,7);
mc_cu = y(1:N,8);
ptil_cu = y(1:N,9);
h_cu = y(1:N,10);
rk_cu = y(1:N,11);
q_cu = y(1:N,12);
% yp;
r_cup = y(2:N+1,1);
c_cup = y(2:N+1,2);
iv_cup = y(2:N+1,3);
pai_cup = y(2:N+1,4);
xtwo_cup = y(2:N+1,5);
y_cup = y(2:N+1,6);
w_cup = y(2:N+1,7);
mc_cup = y(2:N+1,8);
ptil_cup = y(2:N+1,9);
h_cup = y(2:N+1,10);
rk_cup = y(2:N+1,11);
q_cup = y(2:N+1,12);
 
%% Setting the dimension of the matrices 
f = zeros(ny+mx,N);
%% f Function evaluation
% START DISPLAYING f
f(1,:)=- (BETTA.*exp(-d_cu).*exp(-q_cu).*exp(d_cup).*exp(c_cu).^PHItwo.*(exp(q_cup).*(DELTA - 1) - exp(rk_cup) + (KAPA.*exp(q_cup).*(IV./K - exp(-k_cup).*exp(iv_cup)).^2)./2 + KAPA.*exp(-k_cup).*exp(iv_cup).*exp(q_cup).*(IV./K - exp(-k_cup).*exp(iv_cup))))./exp(c_cup).^PHItwo - 1;
f(2,:)=(BETTA.*exp(-d_cu).*exp(-pai_cup).*exp(d_cup).*exp(c_cu).^PHItwo.*(exp(r_cu) + 1))./exp(c_cup).^PHItwo - 1;
f(3,:)=(ETA.*exp(-xtwo_cu).*((exp(mc_cu).*exp(y_cu))./exp(ptil_cu).^(ETA + 1) + (ALFA.*BETTA.*exp(-d_cu).*exp(d_cup).*exp(xtwo_cup).*exp(c_cu).^PHItwo.*(ETA - 1))./(ETA.*exp(-pai_cup).^ETA.*exp(c_cup).^PHItwo.*(exp(-ptil_cup).*exp(ptil_cu)).^(ETA + 1))))./(ETA - 1) - 1;
f(4,:)=(exp(-xtwo_cu).*exp(y_cu))./exp(ptil_cu).^ETA + (ALFA.*BETTA.*exp(-pai_cup).^(1 - ETA).*exp(-d_cu).*exp(-xtwo_cu).*exp(d_cup).*exp(xtwo_cup).*exp(c_cu).^PHItwo)./(exp(c_cup).^PHItwo.*(exp(-ptil_cup).*exp(ptil_cu)).^ETA) - 1;
f(5,:)=exp(-y_cu).*exp(c_cu) + exp(-y_cu).*exp(iv_cu) - 1;
f(6,:)=exp(-s_cup).*exp(-y_cu).*exp(h_cu).^(1 - THETA).*exp(k_cu).^THETA - 1;
f(7,:)=(PHIzero.*exp(-w_cu).*exp(c_cu).^PHItwo)./(1 - exp(h_cu)).^PHIone - 1;
f(8,:)=- (exp(-w_cu).*exp(mc_cu).*(THETA - 1))./(exp(-k_cu).*exp(h_cu)).^THETA - 1;
f(9,:)=RHOR.*log(exp(r_ba1)./(R - 1)) - log(exp(r_cu)./(R - 1)) - ((BETTAY.*log(exp(y_cu)./Y) + BETTAPAI.*log(exp(pai_cu)./PAI)).*(RHOR - 1))./(R - 1);
f(10,:)=ALFA.*exp(-pai_cu).^(1 - ETA) - exp(ptil_cu).^(1 - ETA).*(ALFA - 1) - 1;
f(11,:)=THETA.*exp(-rk_cu).*exp(mc_cu).*(exp(-k_cu).*exp(h_cu)).^(1 - THETA) - 1;
f(12,:)=exp(q_cu).*(KAPA.*(IV./K - exp(-k_cu).*exp(iv_cu)) + 1) - 1;
f(13,:)=exp(-k_cup).*exp(iv_cu) - exp(-k_cup).*exp(k_cu).*(DELTA - 1) - (KAPA.*exp(-k_cup).*exp(k_cu).*(IV./K - exp(-k_cu).*exp(iv_cu)).^2)./2 - 1;
f(14,:)=ALFA.*exp(-s_cup).*exp(s_cu).*exp(pai_cu).^ETA - (exp(-s_cup).*(ALFA - 1))./exp(ptil_cu).^ETA - 1;
% END DISPLAYING f
 
F = reshape(f,N*(ny+mx),1);
end
