clear


EPer = load('Euler_paramsVersion1_sim1000_sameShocksON0_GH_points5_residualMax0.0001_maxDistSS0.03.mat');

Per  = load('Euler_paramsVersion1_sim1000_sameShocksON0_GH_points5_StandardPer.mat');


close all
figureSize      = [0 0 1800 600+300]; % (0,0) size in x size in y
figure('Name','Simulated Sample','NumberTitle','off','Position',figureSize);
markerSize      = 5;
fontSizeValue   = 15;
fontSizeText    = 18;
LineWidthValue  = 1.5;
numSim          = size(EPer.xSim_EPer,2);
burnIn          = size(EPer.ySim_EPer,2)-numSim;
ySim_EPer       = EPer.ySim_EPer(:,burnIn+1:end);
ySim_Per        = Per.ySim_Per(:,burnIn+1:end);


idx        = 1:numSim;
subplot(2,1,1);
hold on
plot(idx,4*exp(ySim_EPer(1,:)),'-k')
plot(idx,4*exp(ySim_Per(1,:)),':b','LineWidth',LineWidthValue)
set(gca,'FontSize',fontSizeValue)
title('Annualized short rate: $r_t$','interpreter','Latex','FontSize',fontSizeText)
axis([1 numSim 0 0.16])
hold off
legend({'Extended Perturbation','Standard Perturbation'},'Orientation','horizontal','Location','NorthEast','EdgeColor',[1 1 1],...
    'interpreter','Latex','FontSize',fontSizeText);


subplot(2,1,2)
hold on
plot(idx,log10(mean(abs(EPer.ResEuler_EPer(:,:,2)),2)),'-k')
plot(idx,log10(mean(abs(Per.ResEuler_Per(:,:,2)),2)),':b','LineWidth',LineWidthValue)
set(gca,'FontSize',fontSizeValue)
title('Euler errors: $\log_{10}$(MAE$_t$)','interpreter','Latex','FontSize',fontSizeText)
axis([1 numSim -5 -1])

